<script setup lang="ts">
import { computed } from 'vue';
import { useLocalizedVimeoSubtitles } from '@/composables/useLocalizedVimeoSubtitles';
import { pushToDataLayer } from '@/utils/trackEvents';

const props = defineProps({
  videoSrc: {
    required: true,
    type: String,
  },
  title: {
    required: false,
    type: String,
  },
  thumbnailSrc: {
    required: false,
    type: String,
    default: '/images/vimeo-placeholder.jpg',
  },

  loading: {
    type: String,
    required: false,
    validator(value) {
      return ['eager', 'lazy'].includes(value);
    },
    default: 'lazy', // impacts cwv
  },
});

const videoId = computed(() => {
  if (props.videoSrc.includes('youtube')) {
    const match = props.videoSrc.match(/(?:v=|\/)([0-9A-Za-z_-]{11})/);
    return match ? match[1] : '';
  } else if (props.videoSrc.includes('vimeo')) {
    const match = props.videoSrc.match(/(?:video\/|\/)([0-9]+)/);
    return match ? match[1] : '';
  }
  return '';
});

const playerType = computed(() => {
  if (props.videoSrc.includes('youtube')) {
    return 'youtube';
  } else if (props.videoSrc.includes('vimeo')) {
    return 'vimeo';
  } else {
    throw new Error(
      `The CommonVideo component has been given a link to an unsupported video type. Please check that it contains an embedded Youtube or Vimeo link. Video source url provided: ${videoSrc}`,
    );
  }
});

const handleEnterDown = (e: KeyboardEvent) => {
  const el = e.target;
  if (el) {
    // The facade component only fires with a 'mousedown' event and not a simple click()
    const mousedownEvent = new MouseEvent('mousedown', {
      bubbles: true,
      cancelable: true,
      view: window,
    });
    el.dispatchEvent(mousedownEvent);
  }
};

// TODO: Implement GTM tracking for youtube player
const milestones = [0.25, 0.5, 0.75, 1];
const milestonesReached = new Set<number>();

// Event Handlers
const handlePlayerEvent = (eventType: keyof EventMap, e: EventMap[keyof EventMap]) => {
  const eventLabel = props.title || videoId.value;
  switch (eventType) {
    case 'play':
    case 'pause':
    case 'ended':
    case 'loaded':
      pushToDataLayer(eventType, 'Video', eventLabel, 'Vimeo Video', { videoId: videoId.value });
      break;

    case 'progress': {
      const percent = (e as EventMap['progress']).percent;
      milestones.forEach((milestone) => {
        if (percent >= milestone && !milestonesReached.has(milestone)) {
          milestonesReached.add(milestone);
          pushToDataLayer(`progress_${milestone * 100}`, 'Video', eventLabel, 'Vimeo Video', {
            videoId: videoId.value,
          });
        }
      });
      break;
    }
  }
};
const vimeoEventHandlers = {
  play: (e: EventMap['play'], player: Player) => handlePlayerEvent('play', e, player),
  pause: (e: EventMap['pause'], player: Player) => handlePlayerEvent('pause', e, player),
  ended: (e: EventMap['ended'], player: Player) => handlePlayerEvent('ended', e, player),
  progress: (e: EventMap['progress'], player: Player) => handlePlayerEvent('progress', e, player),
  loaded: (e: EventMap['loaded'], player: Player) => handlePlayerEvent('loaded', e, player),
};
</script>

<template>
  <div :class="`video-wrapper videoId-${videoId}`" @keydown.enter="handleEnterDown">
    <ScriptYouTubePlayer v-if="playerType === 'youtube'" ref="video" class="video" :video-id="videoId" tabindex="0">
      <template #awaitingLoad>
        <div class="video-thumbnail__play-icon">
          <svg height="100%" version="1.1" viewBox="0 0 68 48" width="70px">
            <path
              d="M66.52,7.74c-0.78-2.93-2.49-5.41-5.42-6.19C55.79,.13,34,0,34,0S12.21,.13,6.9,1.55 C3.97,2.33,2.27,4.81,1.48,7.74C0.06,13.05,0,24,0,24s0.06,10.95,1.48,16.26c0.78,2.93,2.49,5.41,5.42,6.19 C12.21,47.87,34,48,34,48s21.79-0.13,27.1-1.55c2.93-0.78,4.64-3.26,5.42-6.19C67.94,34.95,68,24,68,24S67.94,13.05,66.52,7.74z"
              fill="#f00"
            />
            <path d="M 45,24 27,14 27,34" fill="#fff" />
          </svg>
        </div>
      </template>
    </ScriptYouTubePlayer>
    <ScriptVimeoPlayer
      v-else-if="playerType === 'vimeo'"
      :id="Number(videoId)"
      ref="video"
      :vimeo-options="{ texttrack: useLocalizedVimeoSubtitles() }"
      class="video"
      :title="true"
      tabindex="0"
      v-on="vimeoEventHandlers"
      @keydown.enter="handleEnterDown"
    >
      <template #placeholder>
        <NuxtImg class="video-thumbnail" :src="thumbnailSrc" :loading="loading" alt="Video Placeholder" />
        <slot name="customPlayButton">
          <div class="video-thumbnail__play-icon">
            <svg width="48" height="48" viewBox="0 0 48 48" fill="none" xmlns="http://www.w3.org/2000/svg">
              <circle opacity="0.75" cx="24" cy="24" r="24" class="circle" />
              <path
                d="M19.4339 34.0523C19.2888 34.1455 19.1261 34.2081 18.9559 34.2362C18.7857 34.2642 18.6116 34.2572 18.4442 34.2154C18.2768 34.1737 18.1197 34.0981 17.9827 33.9934C17.8456 33.8887 17.7313 33.757 17.647 33.6065C17.5205 33.3896 17.454 33.1429 17.4546 32.8918V15.979C17.4546 15.2269 18.0358 14.6182 18.7545 14.6182C18.9957 14.619 19.2316 14.6892 19.4339 14.8204L32.5451 23.2758C32.7351 23.404 32.8906 23.5769 32.9982 23.7792C33.1058 23.9816 33.162 24.2072 33.162 24.4363C33.162 24.6655 33.1058 24.8911 32.9982 25.0935C32.8906 25.2958 32.7351 25.4687 32.5451 25.5969L19.4339 34.0523Z"
                fill="white"
              />
            </svg>
          </div>
        </slot>
      </template>
    </ScriptVimeoPlayer>
  </div>
</template>

<style lang="scss" scoped>
.video-wrapper {
  width: 100%;
  position: relative;

  .video {
    cursor: pointer;
    height: 100% !important; // Iframe style override
    width: 920px !important;
    @media (max-width: $breakpoint-lg) {
      width: 100% !important; // Iframe style override
    }
    &:deep(.vimeo-player),
    &:deep(.video-thumbnail) {
      height: 100%;
    }
  }

  .video-thumbnail {
    width: 100%;
    height: auto;
    object-fit: cover;

    // specific to Vimeo player
    &:hover + .video-thumbnail__play-icon {
      .circle {
        fill: #7d2bd9;
        opacity: 1;
      }
    }
  }

  // specific to Vimeo player
  .video-thumbnail__play-icon {
    position: absolute;
    top: 40%;
    right: 47%;
    opacity: 0.75;
    transition: all 0.3s;

    .circle {
      fill: #333333;
      transition: all 0.3s ease-in-out;
    }
  }
}
</style>
